// edbmf.h
#include	<Be.h>

struct GLYPH{
	int16	gl;			//data length -.undefined 0.no-data +.size
	int16	l,t,r,b;	//left,top,right,bottom
	float	w,h;		//width,height?
	uchar	*p;			//pointer(bitmap area)
};

class edbmfview:public BView
{
	public:
		edbmfview(BRect frame);
		void	AttachedToWindow();
		void	Draw(BRect rect);
		void	MouseDown(BPoint mp);
		void	MessageReceived(BMessage *msg);
		void	redraw(bool cf=true);
		void	glf2mtx();
		void	mtx2glf();
		int		load(entry_ref &eref);
		int		save(entry_ref &dir,char *name);
	private:
		BTextControl	*tc,*tw;
		BButton	*bo,*bc;
		BFilePanel	*fp;
		uchar	*mt;		//chr.matrix
		uint16	ec;			//editing chr.code
		float	ew;			//editing chr.width
		BBitmap	*bm;
		int		bx,by;		//bitmap offset
		int		ps;			//size of pixel
};

class edbmfwindow:public BWindow
{
	public:
		edbmfwindow(BRect frame);
		bool	QuitRequested();
		void	setupmenus();
		edbmfview	*v;
};

class edbmf:public BApplication
{
	public:
		edbmf();
		void	RefsReceived(BMessage *mes);
		void	MessageReceived(BMessage *mes);
		edbmfwindow	*w;
};

int		ef;		//edit(file) flag   0.nodata  1.noedit  2.edited

GLYPH	*g=NULL;
uint	hdl,lcl,dtl;
uchar	*hd,*lc,*dt;
uint	ltc;

char	ff[64],fs[64];	//font family,style
int		pt;				//point

uint32	pal[]={
	0x000000,0x202020,0x484848,0x686868,0x909090,0xb0b0b0,0xd8d8d8,0xffffff
};

